#!/bin/bash

KYARCH=$(arch)

###chroot
if [ ! -e /target/dev ];then
  mkdir -p /target/dev
  chmod 755 /target/dev
fi
if [ ! -e /target/proc ];then
  mkdir -p /target/proc
  chmod 555 /target/proc
fi
if [ ! -e /target/sys ];then
  mkdir -p /target/sys
  chmod 555 /target/sys
fi
if [ ! -e /target/run ];then
  mkdir -p /target/run
  chmod 755 /target/run
fi

mount --bind /dev /target/dev
mount --bind /proc /target/proc
mount --bind /sys /target/sys

if [ "${KYARCH}" == "aarch64" ];then
  if [ -f /target/usr/sbin/update-grub ];then
    echo "${KYARCH}: chroot /target update-grub... "
    chroot /target update-grub
  fi
fi

umount /target/dev
umount /target/proc
umount /target/sys


###nochroot
if [ "${KYARCH}" == "aarch64" ];then
  if [ -d /target/boot/efi ];then
    mkdir -p /target/boot/efi/boot/grub
    cp /target/boot/grub/grub.cfg /target/boot/efi/boot/grub
    cp /target/boot/grub/grub.cfg /target/boot/grub/grub.cfg-old
    GRUB_DEVICE_BOOT=`grub-probe --target=device /target/boot`
    GRUB_ROOT=`grub-probe --device $GRUB_DEVICE_BOOT --target=compatibility_hint`
    GRUB_EFI_CFG="/target/boot/efi/boot/grub/grub.cfg"
    sed -i "s/set root=(\${root})/set root='$GRUB_ROOT'/g" $GRUB_EFI_CFG
    sed -i 's#/uImage #/Image #g' $GRUB_EFI_CFG
    sed -i 's/console=ttyS.,115200 earlyprintk=uart8250-32bit,0x28001000//g' $GRUB_EFI_CFG
    sed -i '/devicetree/d' $GRUB_EFI_CFG
    # cp /target/boot/efi/boot/grub/grub.cfg /target/boot/grub/grub.cfg
  fi
fi

if [ "${KYARCH}" == "x86_64" ];then
  if [ -f /target/boot/efi/EFI/kylin/grubx64.efi ] && [ ! -f /target/boot/efi/EFI/boot/bootx64.efi ] && [ ! -f /target/boot/efi/EFI/BOOT/BOOTX64.EFI ];then
    mkdir -p /target/boot/efi/EFI/boot
    cp /target/boot/efi/EFI/kylin/grubx64.efi /target/boot/efi/EFI/boot/bootx64.efi
  fi
fi

